var labelType, useGradients, nativeTextSupport, animate;

(function() {
  var ua = navigator.userAgent,
      iStuff = ua.match(/iPhone/i) || ua.match(/iPad/i),
      typeOfCanvas = typeof HTMLCanvasElement,
      nativeCanvasSupport = (typeOfCanvas == 'object' || typeOfCanvas == 'function'),
      textSupport = nativeCanvasSupport 
        && (typeof document.createElement('canvas').getContext('2d').fillText == 'function');
  //I'm setting this based on the fact that ExCanvas provides text support for IE
  //and that as of today iPhone/iPad current text support is lame
  labelType = (!nativeCanvasSupport || (textSupport && !iStuff))? 'Native' : 'HTML';
  nativeTextSupport = labelType == 'Native';
  useGradients = nativeCanvasSupport;
  animate = !(iStuff || !nativeCanvasSupport);
})();

var Log = {
  elem: false,
  write: function(text){
    if (!this.elem) 
      this.elem = document.getElementById('log');
    this.elem.innerHTML = text;
    this.elem.style.left = (500 - this.elem.offsetWidth / 2) + 'px';
  }
};


function init(){
   // init data
  var json = [
      {
        "adjacencies": [
            "whatisaurl", 
            {
            "nodeTo": "server",
            "nodeFrom": "howisawebpage",
            }, 
            
            {
            "nodeTo": "stylesheet",
            "nodeFrom": "howisawebpage",
            }, 
            
            {
            "nodeTo": "script",
            "nodeFrom": "howisawebpage",
            }, 
            
            {
            "nodeTo": "images",
            "nodeFrom": "howisawebpage",
            }, 
            
            
            {
            "nodeTo": "sourcemap",
            "nodeFrom": "howisawebpage",
            }, 
            
            
            {
            "nodeTo": "html",
            "nodeFrom": "howisawebpage",
            }
            
        ],
        
        
        "data": {"$color": "#EBB056","$type": "circle","$dim": 12},
        "id": "howisawebpage",
        "name": "How is a webpage downloaded?"
    }, 
      
      
      {
     "adjacencies": [
     
     		{
            "nodeTo": "docorder",
            "nodeFrom": "html",
            },
            
            {
            "nodeTo": "doctype",
            "nodeFrom": "html",
            },
            
            {
            "nodeTo": "plugins",
            "nodeFrom": "html",
            },
            
            
            {
            "nodeTo": "html5",
            "nodeFrom": "html",
            },
            
            
            {
            "nodeTo": "header",
            "nodeFrom": "html",
            },
            
            
            {
            "nodeTo": "basicsoflayout",
            "nodeFrom": "html",
            },
            
            
            {
            "nodeTo": "boxinline",
            "nodeFrom": "html",
            },
            
            
            {
            "nodeTo": "whatsmarkup",
            "nodeFrom": "html",
            },
            
            {
            "nodeTo": "standards",
            "nodeFrom": "html",
            }
            
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "html",
     "name": "HTML"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "docorder",
     "name": "Document Order vs. display order"
    }, 
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "doctype",
     "name": "DOCTYPE"
    }, 
    {
     "adjacencies": [
     
     {
            "nodeTo": "flash",
            "nodeFrom": "plugins",
            },
            
            {
            "nodeTo": "silverlight",
            "nodeFrom": "plugins",
            }
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "plugins",
     "name": "Plugins"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "flash",
     "name": "Flash"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "silverlight",
     "name": "Silverlight"
    }, 
    
    
    {
     "adjacencies": [
     		{
            "nodeTo": "webgl",
            "nodeFrom": "html5",
            },
            
            
            {
            "nodeTo": "canvas",
            "nodeFrom": "html5",
            }
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "html5",
     "name": "HTML5"
    }, 
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "webgl",
     "name": "WebGL (OMG Complex)"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "canvas",
     "name": "Canvas (drawing, interacting with control)"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "header",
     "name": "&lt; header &gt;"
    }, 
    {
     "adjacencies": [
     
      		{
            "nodeTo": "a",
            "nodeFrom": "basicsoflayout",
            },


      		{
            "nodeTo": "div",
            "nodeFrom": "basicsoflayout",
            },
            
            
      		{
            "nodeTo": "h1",
            "nodeFrom": "basicsoflayout",
            },
            
            
            
      		{
            "nodeTo": "form",
            "nodeFrom": "basicsoflayout",
            },
            
            
            
      		{
            "nodeTo": "table",
            "nodeFrom": "basicsoflayout",
            },
            
            
            
      		{
            "nodeTo": "bodypage",
            "nodeFrom": "basicsoflayout",
            },     

     
      		{
            "nodeTo": "img",
            "nodeFrom": "basicsoflayout",
            }
     
     
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "basicsoflayout",
     "name": "Basics of Layout"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "img",
     "name": "&lt;img&gt;"
    }, 
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "a",
     "name": "&lt;a&gt;"
    }, 
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "div",
     "name": "&lt;div&gt;"
    }, 
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "h1",
     "name": "&lt;h1&gt;"
    }, 
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "form",
     "name": "&lt;form&gt;"
    }, 
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "bodypage",
     "name": "body = page"
    }, 
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "table",
     "name": "&lt;table&gt;"
    }, 
    
    
    
    {
     "adjacencies": [
     
     {
  	   "nodeTo": "displaytypes",
       "nodeFrom": "boxinline",
       },
       
       {
  	   "nodeTo": "float",
       "nodeFrom": "boxinline",
       },
       
       {
  	   "nodeTo": "flow",
       "nodeFrom": "boxinline",
       },
       
       {
  	   "nodeTo": "boxmodel",
       "nodeFrom": "boxinline",
       }	
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "boxinline",
     "name": "Box and Inline"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "displaytypes",
     "name": "Display Types"
    }, 
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "float",
     "name": "Float"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "flow",
     "name": "Flow"
    }, 
    
    {
     "adjacencies": [
     {
  	   "nodeTo": "padding",
       "nodeFrom": "boxmodel",
       },
       
       {
  	   "nodeTo": "margin",
       "nodeFrom": "boxmodel",
       },
       
       {
  	   "nodeTo": "css",
       "nodeFrom": "boxmodel",
       }
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "boxmodel",
     "name": "Box Model"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "padding",
     "name": "Padding"
    }, 
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "margin",
     "name": "Margin"
    }, 
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "css",
     "name": "CSS"
    }, 
    
    
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "whatsmarkup",
     "name": "What is markup?"
    }, 
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "standards",
     "name": "Standards"
    }, 
    
    
    
    
      
      
    {
     "adjacencies": [
     
     {
  	   "nodeTo": "whatisawebpage",
       "nodeFrom": "whatisaurl",
       }	
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "whatisaurl",
     "name": "What is a URL?"
    }, 
      
    {
     "adjacencies": [
     
     {
  	   "nodeTo": "setupserver",
       "nodeFrom": "server",
       }, 
       
       {
  	   "nodeTo": "thingsdownloaded",
       "nodeFrom": "server",
       },	
		
		{
  	   "nodeTo": "forcedownload",
       "nodeFrom": "server",
       },
       
       {
  	   "nodeTo": "whatisawebpage",
       "nodeFrom": "server",
       }	
       
            
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "server",
     "name": "server"
    }, 
    
    
    {
     "adjacencies": [
     
     {
  	   "nodeTo": "indexdb",
       "nodeFrom": "thingsdownloaded",
       },
       
       
       {
  	   "nodeTo": "cachingresources",
       "nodeFrom": "thingsdownloaded",
       },
       
       {
  	   "nodeTo": "html5apache",
       "nodeFrom": "thingsdownloaded",
       },
       
       
       {
  	   "nodeTo": "localstorage",
       "nodeFrom": "thingsdownloaded",
       }	
     
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "thingsdownloaded",
     "name": "When are things downloaded for you?"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "indexdb",
     "name": "IndexDB"
    }, 
    
       {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "cachingresources",
     "name": "Caching of resources"
    }, 
    
       {
     "adjacencies": [
     
     {
  	   "nodeTo": "eventsonline",
       "nodeFrom": "html5apache",
       }	
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "html5apache",
     "name": "HTML5 AppCache + manifest"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "eventsonline",
     "name": "Events for online/offline (JS)"
    }, 
    
      {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "localstorage",
     "name": "Localstorage"
    }, 
    
    
    
    {
     "adjacencies": [
     	
     	{
  	   "nodeTo": "drupal",
       "nodeFrom": "server",
       }, 
       
       {
  	   "nodeTo": "wordpress",
       "nodeFrom": "server",
       },
       
       
       {
  	   "nodeTo": "practicaltasks",
       "nodeFrom": "server"
       }
       
       
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "setupserver",
     "name": "How do I set up a server?"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "drupal",
     "name": "Drupal"
    }, 
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "wordpress",
     "name": "Wordpress"
    }, 
    
    
    {
     "adjacencies": [
     
     {
  	   "nodeTo": "whatisawebpage",
       "nodeFrom": "server",
       }, 
       
       {
  	   "nodeTo": "setupdatabase",
       "nodeFrom": "server",
       },
     
     
     {
  	   "nodeTo": "createmashup",
       "nodeFrom": "server",
       },
       
       {
  	   "nodeTo": "whatiscanvas",
       "nodeFrom": "server",
       },
       
       {
  	   "nodeTo": "whatisvideo",
       "nodeFrom": "server",
       }
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "practicaltasks",
     "name": "Practical Tasks and Questions"
    }, 
    
    
    {
     "adjacencies": [
     
     {
  	   "nodeTo": "viewsource",
       "nodeFrom": "whatisawebpage",
       }
     
     
     ],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "whatisawebpage",
     "name": "What is a web page?"
    },
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "viewsource",
     "name": "View Source (important practice)"
    },
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "setupdatabase",
     "name": "How do I set up a database?"
    },
    
    
     {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "whatiscanvas",
     "name": "What is a canvas?"
    },
    
      {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "whatisvideo",
     "name": "What is a video?"
    }, 
    
     {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "createmashup",
     "name": "How do you create a mashup?"
    }, 
    
    
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "forcedownload",
     "name": "When can you force a download?"
    }, 

    
          
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "images",
     "name": "images"
    }, 
      
    {
     "adjacencies": [],
     "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
     "id": "stylesheet",
     "name": "stylesheet"
    }, 
       
    {
    "adjacencies": [],
    "data": { "$color": "#70A35E","$type": "circle","$dim": 8},
    "id": "script",
    "name": "script"
    },
      
    {
    "adjacencies": [
    
    {
  	   "nodeTo": "firebugdemo",
       "nodeFrom": "sourcemap",
       }, 
       
       
       {
  	   "nodeTo": "changepage",
       "nodeFrom": "sourcemap",
       }, 
       
       {
  	   "nodeTo": "localhacks",
       "nodeFrom": "sourcemap",
       }
    
    ],
    "data": {"$color": "#70A35E","$type": "circle","$dim": 8},
    "id": "sourcemap",
    "name": "How does source map to what is displayed on the page?"
    }, 
      
    
    {
    "adjacencies": [],
    "data": { "$color": "#70A35E","$type": "circle","$dim": 8},
    "id": "firebugdemo",
    "name": "Firebug demo"
    },
    
    
    {
    "adjacencies": [],
    "data": { "$color": "#70A35E","$type": "circle","$dim": 8},
    "id": "changepage",
    "name": "How do I change a page?"
    },
    
    
    {
    "adjacencies": [],
    "data": { "$color": "#70A35E","$type": "circle","$dim": 8},
    "id": "localhacks",
    "name": "Local hacks (Greasemonkey, Jetpacks)"
    },
    
    
         
      
      
  ];
  // end
    var infovis = document.getElementById('infovis');
    var w = infovis.offsetWidth - 20, h = infovis.offsetHeight - 20;
    
    //init Hypertree
    var ht = new $jit.Hypertree({
      //id of the visualization container
      injectInto: 'infovis',
      //canvas width and height
      width: w,
      height: h,
      //Change node and edge styles such as
      //color, width and dimensions.
      Node: {
          dim: 4,
          color: "#8abafc"
      },
      Edge: {
          lineWidth: 1,
          color: "#CCC"
      },
      onBeforeCompute: function(node){
          Log.write("centering");
      },
      //Attach event handlers and add text to the
      //labels. This method is only triggered on label
      //creation
      onCreateLabel: function(domElement, node){
          domElement.innerHTML = node.name;
          $jit.util.addEvent(domElement, 'click', function () {
              ht.onClick(node.id);
          });
      },
      //Change node styles when labels are placed
      //or moved.
      onPlaceLabel: function(domElement, node){
          var style = domElement.style;
          style.display = '';
          style.cursor = 'pointer';
          if (node._depth <= 1) {
              style.fontSize = "1em";
              style.color = "#000";
              style.zIndex="999";
              style.backgroundColor = "#d2d8e0";
              style.borderColor = "#556684";

          } else if(node._depth == 2){
              style.fontSize = "0.75em";
              style.color = "#555";
              style.backgroundColor = "#cdd3db";
              style.borderColor = "#a9b2c1";
              style.opacity = ".8";
              style.zIndex="99";
              
          }else {
              style.display = 'none';
              style.zIndex="9";
          }

          var left = parseInt(style.left);
          var w = domElement.offsetWidth;
          style.left = (left - w / 2) + 'px';
      },
      
      onAfterCompute: function(){
          Log.write("");
          
          //Build the right column relations list.
          //This is done by collecting the information (stored in the data property) 
          //for all the nodes adjacent to the centered node.
          var node = ht.graph.getClosestNodeToOrigin("current");
          var html = "<h4>" + node.name + "</h4><b>Connections:</b>";
          html += "<ul>";
          node.eachAdjacency(function(adj){
              var child = adj.nodeTo;
              if (child.data) {
                  var rel = (child.data.band == node.name) ? child.data.relation : node.data.relation;
                  html += "<li>" + child.name + " " + "<div class=\"relation\">(relation: " + rel + ")</div></li>";
              }
          });
          html += "</ul>";
          $jit.id('inner-details').innerHTML = html;
      }
    });
    //load JSON data.
    ht.loadJSON(json);
    //compute positions and plot.
    ht.refresh();
    //end
    ht.controller.onAfterCompute();
}
